/* qcam - The Quadratic Camera
 *
 * Copyright (C) 2011 - Willem Jan Palenstijn <wjp@usecode.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef QCAM_VIDEO_H
#define QCAM_VIDEO_H

#include "SDL.h"

class VideoPlayer {
public:
	VideoPlayer() { }
	virtual ~VideoPlayer() { }

	virtual bool open(const char* filename, SDL_PixelFormat* format) = 0; 
	virtual bool getFrame(Uint8* buf, int linesize) = 0;

	virtual void getSize(int& width, int& height) const = 0;
};


#endif
